package org.openzen.zencode.java;

import org.openzen.zenscript.parser.*;

import java.io.*;
import java.util.function.*;

public class PreProcessor implements Predicate<ParsedFile> {
    
    private final String name;
    private final Predicate<ParsedFile> call;
    
    public PreProcessor(String name, Predicate<ParsedFile> call) {
        this.name = name;
        this.call = call;
    }
    
    @Override
    public boolean test(ParsedFile parsedFile) {
        try(BufferedReader reader = new BufferedReader(parsedFile.file.open())) {
            if(reader.lines().anyMatch(line -> line.trim().startsWith("#" + name))) {
                return true;
            } else {
                return false;
            }
        } catch(IOException e) {
            e.printStackTrace();
        }
        return false;
    }
    
    
    public Predicate<ParsedFile> getCall() {
        return call;
    }
}
